/*------------------------------------------------------------------------
   Copyright (C) 2002 Marxmeier Software AG

   Project:  ELOQUENCE
   Module:   dlg / dm
   File:     ddeclnt.h
   Function: pc platform run server DDE services header file

   This software and documentation is based in part on HP software
   and documentation under license from Hewlett-Packard Company.
   HP is a trademark of Hewlett-Packard Company.
   Copyright 2002 Hewlett-Packard Company.

   Edit history:
   03.08.1995 - creation (rhg@msede.com)
   18.07.2003 - fix clobber in SetConvItemValue() (#1995)

------------------------------------------------------------------------*/

#ifdef DOS

/*------------------------------------------------------------------------
      definitions
------------------------------------------------------------------------*/

#define APP_MAX_SIZE             32
#define TOPIC_MAX_SIZE           32
#define ITEM_MAX_SIZE            256
#define VALUE_MAX_SIZE           256
#define CONV_MAX_COUNT           8
#define ITEMS_PER_CONV_MAX_COUNT 5


/*------------------------------------------------------------------------
      type definitions
------------------------------------------------------------------------*/

typedef enum THISACK
{
   BUSY,
   ACK,
   NACK,
};

typedef enum PENDINGACK
{
   NONE,
   ADVISE,
   UNADVISE,
   POKE,
   REQUEST,
   EXECUTE,
};


/*------------------------------------------------------------------------
      function prototypes
------------------------------------------------------------------------*/

extern BOOL RegisterDDE(HANDLE, LPCSTR);
extern void SetDDEOwnerWindow(HWND);
extern BOOL AwaitingAck(HWND);
extern enum THISACK WaitForAck(HWND);
extern void ClientAcknowledge(HWND, HWND, LPARAM, BOOL);
extern void ClientReceiveData(HWND, HWND, LPARAM);
extern void ClientTerminate(HWND, HWND);
extern long CALLBACK DDEWndProc(HWND, UINT, WPARAM, LPARAM);
extern void InitAckTimeOut(UINT);
extern void SendAdvise(HWND, HWND, char*);
extern void SendExecute(HWND, HWND, char*);
extern HWND SendInitiate(char *, char*);
extern void SendPoke(HWND, HWND, char*, char*);
extern void SendRequest(HWND, HWND, char*);
extern void SendTerminate(HWND, HWND);
extern void SendUnadvise(HWND, HWND, char*);
extern void TerminateConversations(void);
extern BOOL AddItemToConv(HWND, char*);
extern BOOL AddConv(HWND, HWND, char*, char*);
extern BOOL AtLeastOneConvActive(void);
extern BOOL DoesAdviseAlreadyExist(HWND, char*);
extern HWND FindConvGivenAppTopic(char *, char*);
extern void GetAppAndTopic(HWND, char*, char*);
extern HWND GetHwndServerDDE(HWND);
extern HWND GetNextConv(HWND);
extern enum PENDINGACK GetConvPendingAck(HWND);
extern void InitDataTextMetrics(void);
extern BOOL IsConvInTerminateState(HWND, HWND);
extern BOOL IsHwndClientDDEUsed(HWND);
extern BOOL RemoveItemFromConv(HWND, char*);
extern BOOL RemoveConv(HWND, HWND);
extern void SetConvInTerminateState(HWND, HWND);
extern BOOL SetConvItemValue(HWND, char*, LPSTR, DWORD);
extern BOOL GetConvItemValue(HWND, char*, LPSTR, int);
extern void SetConvPendingAck(HWND, enum PENDINGACK, enum THISACK);

#endif /* DOS */
