/*------------------------------------------------------------------------
   Copyright (C) 2002 Marxmeier Software AG

   Project:  ELOQUENCE
   Module:   dmdrv
   File:     dmdrv_srv.h
   Function: server settings

   loaded from dmdrv.h if DMDRV_CLIENT_API is not set

   Configuration:

      DMDRV_PRIVATE    - defined to access internal data structures

      DMDRV_CLIENT_API - by default, SERVER api definition is visible.

      DLGAPI_INCLUDED  - make client wrapper prototypes visible
                         only meaningfull if DMDRV_CLIENT_API defined

   This software and documentation is based in part on HP software
   and documentation under license from Hewlett-Packard Company.
   HP is a trademark of Hewlett-Packard Company.
   Copyright 2002 Hewlett-Packard Company.

   Edit history:

   09.01.1996 - split

------------------------------------------------------------------------*/

/* @(#)$Revision: 26.1 $ */

#if defined(MSW)
#define FAR_PASCAL _far _pascal
#define FAR_CDECL  _far _cdecl
#elif defined(WIN32)
#define FAR_PASCAL
#define FAR_CDECL
#else
#define FAR_PASCAL FAR PASCAL
#define FAR_CDECL FAR CDECL
#endif

/*
   D R I V E R   G L O B A L S
*/

/* driver specific setup/cleanup */
extern void FAR_PASCAL dmdrv_setup( int argc, char FAR * FAR *argv,
                                    const char FAR *charset );
extern void FAR_PASCAL dmdrv_cleanup( void );

/* */
extern void FAR_PASCAL dmdrv_main( void );
extern int  FAR_PASCAL dmdrv_main_loop( long exit_rule, LPCSTR exit_path );

#ifdef __DMUSER_INCLUDED__
extern int FAR_PASCAL dmdrv_attach_dialog(DM_ID objID, long value);
#endif

/* process client request */
extern int FAR_PASCAL dmdrv_schedule( t_DMDRV FAR *arg );


/*
   S E R V E R   G L O B A L S
*/

extern int dmdrv_debug_flag;

extern void FAR_PASCAL dmdrv_kill( void );
extern void FAR_CDECL dmdrv_debug( int level, LPCSTR fmt, ... );
extern void FAR_CDECL dmdrv_error( LPCSTR fmt, ... );

#ifdef DOS
extern int FAR_PASCAL dmdrv_evnt( void );
#else
extern void dmdrv_evnt( void );
#endif

extern void FAR_PASCAL dmdrv_return( const t_DMDRV FAR *req );
extern int FAR_PASCAL dmdrv_callback( const t_DMDRV FAR *req, const t_DMDRV FAR **res );

#ifdef DMDRV_PRIVATE

/* data interface */
extern void FAR_PASCAL drv_hton( const t_DMDRV FAR *arg_p );
extern void FAR_PASCAL drv_ntoh( t_DMDRV FAR *arg_p );

/* ipc */
extern int FAR_PASCAL ipc_setup( LPCSTR service );
extern void FAR_PASCAL ipc_cleanup( void );
extern int FAR_PASCAL ipc_send( void );
extern int FAR_PASCAL ipc_schedule( void );

extern t_DMDRV_INFO FAR *dmdrv_info;

#endif   /* DMDRV_PRIVATE */
