/*------------------------------------------------------------------------
   Copyright (C) 2002 Marxmeier Software AG

   Project:  ELOQUENCE
   Module:   dmdrv
   File:     server.h
   Function: server common

   This software and documentation is based in part on HP software
   and documentation under license from Hewlett-Packard Company.
   HP is a trademark of Hewlett-Packard Company.
   Copyright 2002 Hewlett-Packard Company.

   Edit history:
   06.02.1994 - calling convention
   10.02.1994 - DmDrv -> DlgSrv, added config.dlg_path
   29.04.1995 - async WINSOCK 1.1
   25.10.2000 - Windows: help_dde_module, help_dde_wait, help_dde_timeout

------------------------------------------------------------------------*/

// config file and section

#define INI_FILE    "eloqcl.ini"
#define INI_SECTION "DlgSrv"
extern char szIniFile[];

// config data

struct Config {
   size_t memsz;           // size of internal memory
   int debug;              // debug level
   char log_fname[80];     // log filename
   char host[40];          // default host name
   char service[40];       // default service
   char def_fname[80];     // defaults file
   char dlg_path[80];      // dlg base path
   char dlg[4];            // .dlg extension mapping
   char idm[4];            // .idm extension mapping
   char idc[4];            // .idc extension mapping
   char help_base_url[80]; // online help base URL
   char file_base_url[80]; // file view base URL
   char man_base_url[80];  // man page base URL
   char charset[16];       // conversion character set
   char help_dde_module[16]; // DDE module, default is "netscape"
#if defined(_WIN32)
   unsigned help_dde_wait;   // DDE wait after exec (default=2500ms)
#endif
   unsigned help_dde_timeout;// DDE timeout (default=15000ms)
};

extern struct Config config;

// driver debug level
extern int dmdrv_debug_flag;

// pointer to arg info
extern t_DMDRV_INFO FAR *dmdrv_info;

// some prototypes of global interest
extern void FAR CDECL StatusMessage( const char FAR *fmt, ...);
extern void FAR CDECL DebugMessage( const char FAR *fmt, ...);
extern void FAR CDECL WarningMessage( const char FAR *fmt, ...);
extern void FAR CDECL ErrorMessage( const char FAR *fmt, ...);

// prototypes of network type converters
#if !defined(WIN32)
unsigned short htons( unsigned short );
unsigned short ntohs( unsigned short );
unsigned long  htonl( unsigned long );
unsigned long  ntohl( unsigned long );
#endif
