/* ----------------------------------------------------------------------
   Copyright (C) 2002 Marxmeier Software AG

   Project:  ELOQUENCE
   Module:   dlg / dm
   File:     bind.c
   Function: bind callback functions

   This software and documentation is based in part on HP software
   and documentation under license from Hewlett-Packard Company.
   HP is a trademark of Hewlett-Packard Company.
   Copyright 2002 Hewlett-Packard Company.

   Edit history:
   20.01.1994 - derived from m_load.c

---------------------------------------------------------------------- */

static char RcsId[] =
   "$Header: /cvs/cvsroot/eloq/B0810/dlgsrv/server/bind.c,v 26.1 2009/05/05 16:28:14 mike Exp $";


/* ----------------------------------------------------------------------
      includes
---------------------------------------------------------------------- */

#include <IDMuser.h>

/* this is used to validate prototypes, if omitted include <windows.h> */
#include "dmdrv.h"


/* ----------------------------------------------------------------------

   bind callbacks

---------------------------------------------------------------------- */

/* callback functions */

DM_Boolean DML_default DM_CALLBACK CB_PushButton(DM_CallBackArgs FAR *);
DM_Boolean DML_default DM_CALLBACK CB_CheckBox(DM_CallBackArgs FAR *);
DM_Boolean DML_default DM_CALLBACK CB_RadioButton(DM_CallBackArgs FAR *);
DM_Boolean DML_default DM_CALLBACK CB_ListBox(DM_CallBackArgs FAR *);
DM_Boolean DML_default DM_CALLBACK CB_EditText(DM_CallBackArgs FAR *);

/* internal */

void DML_default DM_ENTRY ExitEventLoop(DM_ID, long);
DM_Boolean DML_default DM_ENTRY CallBack(LPCSTR, DM_ID, long);
void DML_default DM_ENTRY RestorePopup(void);

/* help functionality */

DM_Boolean DML_default DM_ENTRY HelpOnObject(DM_ID);
DM_Boolean DML_default DM_ENTRY HelpOnTag(DM_ID, LPCSTR);
DM_Boolean DML_default DM_ENTRY HelpViewFile(LPCSTR);
DM_Boolean DML_default DM_ENTRY HelpManPage(LPCSTR);
DM_Boolean DML_default DM_ENTRY CallHelp(LPCSTR, LPCSTR);

/* obsolete dialog functions */
DM_Boolean DML_default DM_ENTRY Obsolete1(DM_ID p1)
{
   (void)p1;
   return FALSE;
}
DM_Boolean DML_default DM_ENTRY Obsolete2(DM_ID p1, LPCSTR p2)
{
   (void)p1;
   (void)p2;
   return FALSE;
}
DM_Boolean DML_default DM_ENTRY Obsolete3(LPCSTR p1, LPCSTR p2)
{
   (void)p1;
   (void)p2;
   return FALSE;
}


#define CFuncCount (sizeof(CFuncMap) / sizeof(CFuncMap[0]))

static DM_FuncMap CFuncMap[] = {
/**/
   { "EqPushButtonCB",    (DM_EntryFunc) CB_PushButton     },
   { "EqRadioButtonCB",   (DM_EntryFunc) CB_RadioButton    },
   { "EqCheckBoxCB",      (DM_EntryFunc) CB_CheckBox       },
   { "EqListBoxCB",       (DM_EntryFunc) CB_ListBox        },
   { "EqEditTextCB",      (DM_EntryFunc) CB_EditText       },
/**/
   { "EqExitEventLoop",   (DM_EntryFunc) ExitEventLoop     },
   { "EqCallBack",        (DM_EntryFunc) CallBack          },
/**/
   { "EqRestorePopup",    (DM_EntryFunc) RestorePopup      },
/**/
   { "EqHelpOnObject",    (DM_EntryFunc) HelpOnObject      },
   { "EqHelpOnTag",       (DM_EntryFunc) HelpOnTag         },
   { "EqHelpViewFile",    (DM_EntryFunc) HelpViewFile      },
   { "EqHelpManPage",     (DM_EntryFunc) HelpManPage       },
/**/
   { "EqHelpOnItem",      (DM_EntryFunc) Obsolete1         },
   { "EqHelpOnVersion",   (DM_EntryFunc) Obsolete1         },
   { "EqQHelpOnObject",   (DM_EntryFunc) Obsolete1         },
   { "EqQHelpOnTag",      (DM_EntryFunc) Obsolete2         },
   { "EqCallHelp",        (DM_EntryFunc) Obsolete3         },
};

void dm_bind_default_callbacks( DM_ID dlgID )
{
   if (!DM_BindFunctions(CFuncMap, CFuncCount, dlgID, 0, DMF_Silent))
      DM_TraceMessage ("Missing callback functions", 0);
}
